#include "Arco.h"
#include <iomanip> // to use the setprecision manipulator

/*********************************************
	Constructores
 *********************************************/

Arco::Arco() 
{
}

Arco::Arco(ifstream & infile) 
{
  infile >> sub_type;
  infile >> line_style;
  infile >> thickness;
  infile >> pen_color;
  infile >> fill_color;
  infile >> depth;
  infile >> pen_style;
  infile >> area_fill;
  infile >> style_val;
  infile >> cap_style; 
  infile >> direction;
  infile >> forward_arrow;  
  infile >> backward_arrow;
  infile >> center_x;
  infile >> center_y;
  infile >> x1;
  infile >> y1;
  infile >> x2;
  infile >> y2;
  infile >> x3;
  infile >> y3;
}

/*********************************************
	Operaciones
 *********************************************/
void Arco::write(void)
{
  cout  << '\n' << object_code << ' ' << sub_type 
       << ' ' << line_style << ' ' << thickness
       << ' ' << pen_color << ' ' << fill_color
       << ' ' << depth << ' ' << pen_style
       << ' ' << area_fill << ' ' << style_val 
       << ' ' << cap_style << ' ' << direction
       << ' ' << forward_arrow << ' ' << backward_arrow
       << ' ' << center_x << ' ' << center_y 
       << ' ' << x1 << ' ' << y1 
       << ' ' << x2 << ' ' << y2
       << ' ' << x3 << ' ' << y3;
}

//-----------------------------------------------------

void Arco::mag(int x, int y, double f)
{
  thickness= int(thickness*f);
  center_x = x+int((center_x-x)*f);
  center_y = y+int((center_y-y)*f);
  x1 = x+int((x1-x)*f);
  y1 = y+int((y1-y)*f);
  x2 = x+int((x2-x)*f);
  y2 = y+int((y2-y)*f);
  x3 = x+int((x3-x)*f);
  y3 = y+int((y3-y)*f);
}

//-----------------------------------------------------

void Arco::trans(int x, int y)
{
  center_x += x;
  center_y += y;
  x1 += x;
  y1 += y;
  x2 += x;
  y2 += y;
  x3 += x;
  y3 += y;
}

//-----------------------------------------------------

void Arco::rot(int x_, int y_, char s)
{ double temp;
  center_x=center_x-x_;
  x1=x1-x_;
  x2=x2-x_;
  x3=x3-x_;
  center_y=y_-center_y;
  y1=y_-y1;
  y2=y_-y2; 
  y3=y_-y3;

  if(s=='F')         // Caso a favor de los punteros del reloj
    { center_x=center_x*-1;
      x1=x1*-1;
      x2=x2*-1;
      x3=x3*-1; 
    }

  if(s=='C')              // Caso en contra de los punteros del reloj
    { center_y=center_y*-1;
      y1=y1*-1;
      y2=y2*-1;
      y3=y3*-1;
    }
 temp=center_x;
 center_x=center_y;
 center_y=temp;

 temp=x1;
 x1=y1;
 y1=(int)temp;

 temp=x2;
 x2=y2;
 y2=(int)temp;

 temp=x3;
 x3=y3;
 y3=(int)temp;
 
 center_x=center_x+x_;
 x1=x1+x_;
 x2=x2+x_;
 x3=x3+x_;

 center_y=y_-center_y;
 y1=y_-y1;
 y2=y_-y2;
 y3=y_-y3;
}


