#ifndef ARCO_H
#define ARCO_H

#include <iostream>
#include <fstream>
#include "Forma.h"

#define ARCO_OBJECT_CODE 5

class Arco:public Forma
{
public:
  Arco();
  Arco(ifstream & inFile);
  
  virtual void write(void);
  virtual void mag(int x, int y, double f);
  virtual void trans(int x, int y);
  virtual void rot(int x, int y, char s);

  static int const object_code=ARCO_OBJECT_CODE;//	(siempre 5)

private:
  int	sub_type;	/*		(1: ellipse defined by radii
					 2: ellipse defined by diameters
					 3: circle defined by radius
					 4: circle defined by diameter) */
  int	line_style;	//		(enumeration type)
  int	thickness;	//		(1/80 inch)
  int	pen_color;	//		(enumeration type, pen color)
  int	fill_color;	//		(enumeration type, fill color)
  int	depth;		//		(enumeration type)
  int	pen_style;	//		(pen style, not used)
  int	area_fill;	//		(enumeration type, -1 = no fill)
  float	style_val;	//		(1/80 inch)
  int   cap_style;
  int	direction;	//		(always 1)
  int 	forward_arrow;	//		
  int   backward_arrow;  
  float	center_x, center_y;	//	(Fig units)
  int	x1, y1;	        //	(Fig units)
  int	x2, y2;	        //	(Fig units; the 1st point entered)
  int	x3, y3;	        //	(Fig units; the last point entered)
};

#endif

