#ifndef ELLIPSE_H
#define ELLIPSE_H

#include <iostream>
#include <fstream>
#include "Forma.h"

#define ELLIPSE_OBJECT_CODE 1

class Ellipse:public Forma
{
 public:
  Ellipse();
  Ellipse(ifstream & inFile);
  
  virtual void write(void);
  virtual void mag(int x, int y, double f);
  virtual void trans(int x, int y);
  virtual void rot(int x, int y, char s);

  static int const object_code=ELLIPSE_OBJECT_CODE;//	(siempre 1)

 private:
  int	sub_type;	/*		(1: ellipse defined by radii
					2: ellipse defined by diameters
					3: circle defined by radius
					4: circle defined by diameter) */
  int	line_style;	//		(enumeration type)
  int	thickness;	//		(1/80 inch)
  int	pen_color;	//		(enumeration type, pen color)
  int	fill_color;	//		(enumeration type, fill color)
  int	depth;		//		(enumeration type)
  int	pen_style;	//		(pen style, not used)
  int	area_fill;	//		(enumeration type, -1 = no fill)
  float	style_val;	//		(1/80 inch)
  int	direction;	//		(always 1)
  float	angle;		//		(radians, the angle of the x-axis)
  int	center_x, center_y;	//	(Fig units)
  int	radius_x, radius_y;	//	(Fig units)
  int	start_x, start_y;	//	(Fig units; the 1st point entered)
  int	end_x, end_y;	//		(Fig units; the last point entered)
};


#endif

