#include "Figura.h"
#include "Ellipse.h"
#include "Text.h"
#include "Arco.h"
#include "Poligono.h"
#include <iomanip> // to use the setprecision manipulator
#define FIN_ARCHIVO NULL

/*********************************************
	Constructores
*********************************************/
Figura::Figura() 
{
}

Figura::Figura(ifstream & infile) 
{
  getline(infile,version);
  infile >> orientation >> justification >> units >> papersize;
  infile >> magnification;
  infile >> multiple_page;
  infile >> transparent_color >> resolution >> coord_system;

  while(!infile.eof()){
    int type;
    type =0;
    infile >> type;

    // aqui se elige que tipo de figura es con su respectivo codigo xfig

    switch(type) {
    case ELLIPSE_OBJECT_CODE: vforma.push_back(new Ellipse(infile));
      break;
    case TEXT_OBJECT_CODE: vforma.push_back(new Text(infile));
      break;
    case ARCO_OBJECT_CODE: vforma.push_back(new Arco(infile));
      break;
    case POLIGONO_OBJECT_CODE: vforma.push_back(new Poligono(infile));
      break;   
    case FIN_ARCHIVO:;
      break;
    default:
      cerr << "Tipo o clase de forma no esperado : " << type << endl;
      return;
    }
  }
}

/*********************************************
	Operaciones
*********************************************/
void Figura::write(void)
{
  cout << version << '\n';
  cout << orientation << '\n';
  cout << justification << '\n';
  cout << units << '\n';
  cout << papersize << '\n';
  cout << magnification << '\n';
  cout << multiple_page << '\n';
  cout << transparent_color << '\n';
  cout << resolution << ' ' << coord_system;
  for (int i=0; i<vforma.size(); i++)
    vforma[i]->write();
}

  
//-----------------------------------------------------

void Figura::mag(int x, int y, double f)
{
  for (int i=0; i<vforma.size(); i++)
    vforma[i]->mag(x,y,f);
}

//-----------------------------------------------------

void Figura::trans(int x, int y)
{
  for (int i=0; i<vforma.size(); i++)
    vforma[i]->trans(x,y);
}

//-----------------------------------------------------

void Figura::rot(int x, int y, char s)
{
  for (int i=0; i<vforma.size(); i++)
    vforma[i]->rot(x,y,s);
}

