#ifndef FIGURA_H
#define FIGURA_H

#include <vector>
#include <iostream>
#include <fstream>
#include <string>
#include "Forma.h"

class Figura 
{
 public:
  Figura ();
  Figura (ifstream & infile);
  
  void write(void);
  void mag(int x, int y, double f);
  void trans(int x, int y);
  void rot(int x, int y, char s);

 private:
  vector<Forma *> vforma;
  string	version;       //	(name and version)
  string	orientation;   //	("Landscape" or "Portrait")
  string	justification; //	("Center" or "Flush Left")
  string	units;         //	("Metric" or "Inches")
  string	papersize;     /*	("Letter", "Legal", "Ledger", "Tabloid",
					"A", "B", "C", "D", "E",
					"A4",   "A3", "A2", "A1", "A0" and "B5")*/
  float	        magnification; //	(export and print magnification, %)
  string        multiple_page; //		("Single" or "Multiple" pages)
  int	        transparent_color;     /*	(color number for transparent color for GIF
						export. -3=background, -2=None, -1=Default,
						0-31 for standard colors or 32- for user colors)*/
  int	        resolution,coord_system; /*	(Fig units/inch and coordinate system:
						1: origin at lower left corner (NOT USED)
						2: upper left) */
};


#endif
