#include "Poligono.h"
#include <iomanip> // to use the setprecision manipulator
#include <vector>


/*********************************************
	Constructores
*********************************************/

Poligono::Poligono() 
{
}
Poligono::Poligono(ifstream & infile) 
{ 
  infile >> sub_type;      // 3 para el poligono
  infile >> line_style;
  infile >> thickness;
  infile >> pen_color;
  infile >> fill_color;
  infile >> depth;
  infile >> pen_style;
  infile >> area_fill;
  infile >> style_val;
  infile >> join_style;
  infile >> cap_style;
  infile >> radius;
  infile >> forward_arrow;
  infile >> backward_arrow;
  infile >> npoints;
  p=(int *)malloc((2*npoints)*sizeof(int));  /*Poligonos tienen cantidad de puntos no 
					       conocida y necesario el uso de asignacion de memoria dinamica*/
  for(int n=0;n<(2*npoints);n++)  // +5
    {
      infile >> *(p+n);	  
   
    };
  //           infile>> back; 
}

/*********************************************
	Operaciones
*********************************************/
void Poligono::write(void)
{
  m=0;
  cout << '\n' << object_code << ' ' << sub_type 
       << ' ' << line_style << ' ' << thickness
       << ' ' << pen_color << ' ' << fill_color
       << ' ' << depth << ' ' << pen_style
       << ' ' << area_fill << ' ' << style_val << ' ' << join_style
       << ' ' << cap_style << ' ' << radius << ' ' << forward_arrow 
       << ' ' << backward_arrow << ' ' << npoints
       << ' ' << '\n' <<'\t';
  
  for(int n=0;n<(2*npoints);n++)     //Para inprimir los puntos que son de cantidad variable
    {    
      cout << *(p+n)<< ' ' ;         //uso de memoria dinmica de sistema
      m++;  
      if(m==12 && n!=(2*npoints-1))  // Para enviar un salto de linea cuando pasan 12 coordenadas (formato xfig para poligono)
	{ cout << '\n' << '\t';
	m=0;
	};
    
    };     
   
}

//-----------------------------------------------------

void Poligono::mag(int x_, int y_, double f)
{   thickness= int(thickness*f);
  
 for(int n=0;n<(npoints);n++)
   {  
     p[2*n]=x_+int((p[2*n]-x_)*f);     //
     p[2*n+1]=y_+int((p[2*n+1]-y_)*f);
   };

}

//-----------------------------------------------------

void Poligono::trans(int x, int y)
{
  for(int n=0;n<(npoints);n++)
    {
      p[2*n]=p[2*n]+x;
      p[2*n+1]=p[2*n+1]+y;
    }	  
}

//-----------------------------------------------------

void Poligono::rot(int x_, int y_, char s)
{ double temp;
 
 for(int n=0;n<(npoints);n++)
   {  
     p[2*n]=p[2*n]-x_;
     p[2*n+1]=y_-p[2*n+1];
   };

 if(s=='F')
   { for(int n=0;n<(npoints);n++)
     { 
       p[2*n]=p[2*n]*-1;
     };
   }

 if(s=='C')
   {   
     for(int n=0;n<(npoints);n++)
       {  
	 p[2*n+1]=p[2*n+1]*-1;
       }; 
   }

 for(int n=0;n<(npoints);n++)
   { 
     temp=p[2*n];
     p[2*n]=p[2*n+1];
     p[2*n+1]=(int)temp;
   };
  
 for(int n=0;n<(npoints);n++)
   { 
     p[2*n]=p[2*n]+x_;
     p[2*n+1]=y_-p[2*n+1];
   };
}


