
#ifndef POLIGONO_H
#define POLIGONO_H

#include <iostream>
#include <vector>
#include <fstream>
#include "Forma.h"

#define POLIGONO_OBJECT_CODE 2

class Poligono:public Forma
{
 public:
  Poligono();
  Poligono(ifstream & inFile);
  
  virtual void write(void);
  virtual void mag(int x, int y, double f);
  virtual void trans(int x, int y);
  virtual void rot(int x, int y, char s);

  static int const object_code=POLIGONO_OBJECT_CODE;//	(siempre 2)
  int n;
  int *p;

 private:
  int	sub_type;	/*		(1: ellipse defined by radii
					2: ellipse defined by diameters
					3: circle defined by radius
					4: circle defined by diameter) */
  int	line_style;	//		(enumeration type)
  int	thickness;	//		(1/80 inch)
  int	pen_color;	//		(enumeration type, pen color)
  int	fill_color;	//		(enumeration type, fill color)
  int	depth;		//		(enumeration type)
  int	pen_style;	//		(pen style, not used)
  int	area_fill;	//		(enumeration type, -1 = no fill)
  float	style_val;	//		(1/80 inch)
  int	join_style;	//		(always 1)
  int cap_style;
  int   radius;		//		(radians, the angle of the x-axis)
  int	forward_arrow, backward_arrow;	//	(Fig units)
  int	npoints;	//	(Fig units)
  int m;
  int back;
  int l;
};


#endif
