#include "Text.h"
#include <stdio.h>
/*********************************************
	Constructores
*********************************************/
Text::Text() 
{
}

Text::Text(ifstream & infile) 
{
  infile >> sub_type >> color >> depth >> pen_style >> font;
  infile >> font_size >> angle >> font_flags;
  infile >> height >> length >> x >> y;
  stringText = readText(infile);
}

/*********************************************
	Operaciones
*********************************************/
string Text::readText(ifstream &infile) 
{
  char c;
  string s;
  const string tail001="\\001";
  getline(infile,s);  
  s+=c;   		   // added to s. Text might have new lines.
 
  while(s.substr(s.length()-5,4) != tail001){
    infile >> c;     // need to read even blank spaces.
    
    s += c;          // se van agregando los valores al string
  }
  return s;
}

//--------------------------------------------

void Text::write(void) 
{
  cout << '\n' << object_code << ' ';  
  cout << sub_type <<' '<< color << ' '
       << depth  <<' ' << pen_style <<' ' << font << ' '
       << font_size <<' ' << angle << ' '
       << font_flags << ' ' << height <<' '
       << length <<' ' << x << ' ' << y << ' '
       << stringText ;
}

//--------------------------------------------

void Text::mag(int xc, int yc, double f)
{
  font_size=int(font_size*f);
  height = int(height*f);
  length = int(length*f);
  x = xc + int((x-xc)*f);
  y = yc + int((y-yc)*f);
}

//-----------------------------------------------------

void Text::trans(int _x, int _y)
{
  x+=_x;
  y+=_y;
}

//-----------------------------------------------------

void Text::rot(int x_, int y_, char s)
{
  double temp;
  // Rotar la posicion x,y en relacion a los datos de giro
  x=x-x_;
  y=y_-y;

  // Reconocer el sentido del giro
  if(s=='F')
    {   if(angle==0.0000){angle=4.7124;}
    if(angle==1.5708){angle=0.0000;}
    if(angle==3.1416){angle=1.5708;}
    if(angle==4.7124){angle=3.1416;}
    x=x*-1;
    }
  if(s=='C')
    {   if(angle==0.0000){angle=1.5708;}
    if(angle==1.5708){angle=3.1416;}
    if(angle==3.1416){angle=4.7124;}
    if(angle==4.7124){angle=0.0000;}
    y=y*-1;

    }

  temp=x;
  x=y;
  y=(int)temp;
  x=x+x_;
  y=y_-y;

}

